Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm	(revision 34921)
@@ -5057,20 +9883,18 @@
         DirLen   => length($data) - $offset,
         DirName  => $$dirInfo{DirName},
-        DataPos  => $$dirInfo{DataPos} + $$dirInfo{DirStart},
+        DataPos  => $$dirInfo{DataPos} + $dirStart,
         Base     => $$dirInfo{Base},
     );
     my $rtnVal;
-    my $oldOrder = GetByteOrder();
-    SetByteOrder($byteOrder) if $byteOrder;
     if ($$dirInfo{IsWriting}) {
-        my $changed = $$exifTool{CHANGED};
-        $rtnVal = $exifTool->WriteBinaryData(\%subdirInfo, $tagTablePtr);
+        my $changed = $$et{CHANGED};
+        $rtnVal = $et->WriteBinaryData(\%subdirInfo, $tagTablePtr);
         # must re-encrypt if serial number or shutter count changes
         if ($recrypt) {
             $serial = $newSerial if defined $newSerial;
             $count = $newCount if defined $newCount;
-            ++$$exifTool{CHANGED};
+            ++$$et{CHANGED};
         }
-        if ($changed == $$exifTool{CHANGED}) {
+        if ($changed == $$et{CHANGED}) {
             undef $rtnVal;  # nothing changed so use original data
         } else {
@@ -5081,5 +9905,5 @@
         }
     } else {
-        $rtnVal = $exifTool->ProcessBinaryData(\%subdirInfo, $tagTablePtr);
+        $rtnVal = $et->ProcessBinaryData(\%subdirInfo, $tagTablePtr);
     }
     SetByteOrder($oldOrder);
@@ -5093,5 +9917,5 @@
 sub PrescanExif($$$)
 {
-    my ($exifTool, $dirInfo, $tagHash) = @_;
+    my ($et, $dirInfo, $tagHash) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dataPos = $$dirInfo{DataPos} || 0;
@@ -5122,10 +9946,8 @@
         $dirStart = 0;
     }
-    # loop through necessary IFD entries
-    my ($lastTag) = sort { $b <=> $a } keys %$tagHash; # (reverse sort)
+    # loop through Nikon MakerNote IFD entries
     for ($index=0; $index<$numEntries; ++$index) {
         my $entry = $dirStart + 2 + 12 * $index;
         my $tagID = Get16u($dataPt, $entry);
-        last if $tagID > $lastTag;  # (assuming tags are in order)
         next unless exists $$tagHash{$tagID};   # only extract required tags
         my $format = Get16u($dataPt, $entry+2);
@@ -5159,11 +9981,11 @@
 sub ProcessNikonCaptureEditVersions($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     require Image::ExifTool::NikonCapture;
-    return Image::ExifTool::NikonCapture::ProcessNikonCaptureEditVersions($exifTool, $dirInfo, $tagTablePtr);
+    return Image::ExifTool::NikonCapture::ProcessNikonCaptureEditVersions($et, $dirInfo, $tagTablePtr);
 }
 
 #------------------------------------------------------------------------------
-# process Nikon Capture Offsets IFD (ref PH)
+# Process Nikon Capture Offsets IFD (ref PH)
 # Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
 # Returns: 1 on success
@@ -5171,5 +9993,5 @@
 sub ProcessNikonCaptureOffsets($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dirStart = $$dirInfo{DirStart};
@@ -5179,6 +10001,6 @@
     my $count = Get16u($dataPt, $dirStart);
     return 0 unless $count and $count * 12 + 2 <= $dirLen;
-    if ($exifTool->Options('Verbose')) {
-        $exifTool->VerboseDir('NikonCaptureOffsets', $count);
+    if ($et->Options('Verbose')) {
+        $et->VerboseDir('NikonCaptureOffsets', $count);
     }
     my $index;
@@ -5187,5 +10009,5 @@
         my $tagID = Get32u($dataPt, $pos);
         my $value = Get32u($dataPt, $pos + 4);
-        $exifTool->HandleTag($tagTablePtr, $tagID, $value,
+        $et->HandleTag($tagTablePtr, $tagID, $value,
             Index  => $index,
             DataPt => $dataPt,
@@ -5198,5 +10020,5 @@
 
 #------------------------------------------------------------------------------
-# Read/write Nikon Makernotes directory
+# Read/write Nikon MakerNotes directory
 # Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
 # Returns: 1 on success, otherwise returns 0 and sets a Warning when reading
@@ -5204,12 +10026,12 @@
 sub ProcessNikon($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
-    $exifTool or return 1;    # allow dummy access
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    $et or return 1;    # allow dummy access
 
     # pre-scan IFD to get SerialNumber (0x001d) and ShutterCount (0x00a7) for use in decryption
     my %needTags = ( 0x001d => 0, 0x00a7 => undef );
-    PrescanExif($exifTool, $dirInfo, \%needTags);
-    $$exifTool{NikonSerialKey} = SerialKey($exifTool, $needTags{0x001d});
-    $$exifTool{NikonCountKey} = $needTags{0x00a7};
+    PrescanExif($et, $dirInfo, \%needTags);
+    $$et{NikonSerialKey} = SerialKey($et, $needTags{0x001d});
+    $$et{NikonCountKey} = $needTags{0x00a7};
 
     # process Nikon makernotes
@@ -5217,16 +10039,16 @@
     if ($$dirInfo{IsWriting}) {
         # get new decryptino keys if they are being changed
-        my $serial = $exifTool->GetNewValues($Image::ExifTool::Nikon::Main{0x001d});
-        my $count = $exifTool->GetNewValues($Image::ExifTool::Nikon::Main{0x00a7});
-        $$exifTool{NewNikonSerialKey} = SerialKey($exifTool, $serial);
-        $$exifTool{NewNikonCountKey} = $count;
-        $rtnVal = Image::ExifTool::Exif::WriteExif($exifTool, $dirInfo, $tagTablePtr);
-        delete $$exifTool{NewNikonSerialKey};
-        delete $$exifTool{NewNikonCountKey};
+        my $serial = $et->GetNewValue($Image::ExifTool::Nikon::Main{0x001d});
+        my $count = $et->GetNewValue($Image::ExifTool::Nikon::Main{0x00a7});
+        $$et{NewNikonSerialKey} = SerialKey($et, $serial);
+        $$et{NewNikonCountKey} = $count;
+        $rtnVal = Image::ExifTool::Exif::WriteExif($et, $dirInfo, $tagTablePtr);
+        delete $$et{NewNikonSerialKey};
+        delete $$et{NewNikonCountKey};
     } else {
-        $rtnVal = Image::ExifTool::Exif::ProcessExif($exifTool, $dirInfo, $tagTablePtr);
+        $rtnVal = Image::ExifTool::Exif::ProcessExif($et, $dirInfo, $tagTablePtr);
     }
-    delete $$exifTool{NikonSerialKey};
-    delete $$exifTool{NikonCountKey};
+    delete $$et{NikonSerialKey};
+    delete $$et{NikonCountKey};
     return $rtnVal;
 }
@@ -5251,5 +10073,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
@@ -5271,4 +10093,6 @@
 
 =item L<http://www.wohlberg.net/public/software/photo/nstiffexif/>
+
+=item (...plus lots of testing with Best Buy store demos!)
 
 =back
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/NikonCapture.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/NikonCapture.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/NikonCapture.pm	(revision 34921)
@@ -9,4 +9,5 @@
 #
 # References:   1) http://www.cybercom.net/~dcoffin/dcraw/
+#               IB) Iliah Borg private communication (LibRaw)
 #------------------------------------------------------------------------------
 
@@ -18,5 +19,5 @@
 use Image::ExifTool::Exif;
 
-$VERSION = '1.07';
+$VERSION = '1.14';
 
 sub ProcessNikonCapture($$$);
@@ -94,4 +95,9 @@
     },
     # 0x3e726567 added when I rotated by 90 degrees
+    0x416391c6 => {
+        Name => 'QuickFix',
+        Writable => 'int8u',
+        PrintConv => \%offOn,
+    },
     0x56a54260 => {
         Name => 'Exposure',
@@ -166,4 +172,5 @@
         },
     },
+  # 0x88f55e48 - related to QuickFix
     0x890ff591 => {
         Name => 'D-LightingHQData',
@@ -184,5 +191,5 @@
         },
     },
-  # 0xa7264a72, 0x88f55e48 and 0x416391c6 all change from 0 to 1 when QuickFix is turned on
+  # 0xa7264a72 - related to QuickFix
     0xab5eca5e => {
         Name => 'PhotoEffects',
@@ -347,21 +354,38 @@
             2 => 'Recorded Value',
             3 => 'Use Temperature',
-            4 => 'Calculate Automatically'
-        },
-    },
-    0x14 => {
-        Name => 'WBAdjLightingSubtype',
-        # this varies for different lighting types
-        # (ie. for Daylight, this is 0 => 'Direct', 1 => 'Shade', 2 => 'Cloudy')
-    },
-    0x15 => {
+            4 => 'Calculate Automatically',
+            5 => 'Auto2', #IB
+            6 => 'Underwater', #IB
+            7 => 'Auto1',
+        },
+    },
+    0x14 => { #IB
         Name => 'WBAdjLighting',
+        Format => 'int16u',
+        PrintHex => 1,
         PrintConv => {
-            0 => 'None',
-            1 => 'Incandescent',
-            2 => 'Daylight',
-            3 => 'Standard Fluorescent',
-            4 => 'High Color Rendering Fluorescent',
-            5 => 'Flash',
+            0x000 => 'None',
+            0x100 => 'Incandescent',
+            0x200 => 'Daylight (direct sunlight)',
+            0x201 => 'Daylight (shade)',
+            0x202 => 'Daylight (cloudy)',
+            0x300 => 'Standard Fluorescent (warm white)',
+            0x301 => 'Standard Fluorescent (3700K)',
+            0x302 => 'Standard Fluorescent (cool white)',
+            0x303 => 'Standard Fluorescent (5000K)',
+            0x304 => 'Standard Fluorescent (daylight)',
+            0x305 => 'Standard Fluorescent (high temperature mercury vapor)',
+            0x400 => 'High Color Rendering Fluorescent (warm white)',
+            0x401 => 'High Color Rendering Fluorescent (3700K)',
+            0x402 => 'High Color Rendering Fluorescent (cool white)',
+            0x403 => 'High Color Rendering Fluorescent (5000K)',
+            0x404 => 'High Color Rendering Fluorescent (daylight)',
+            0x500 => 'Flash',
+            0x501 => 'Flash (FL-G1 filter)',
+            0x502 => 'Flash (FL-G2 filter)',
+            0x503 => 'Flash (TN-A1 filter)',
+            0x504 => 'Flash (TN-A2 filter)',
+            0x600 => 'Sodium Vapor Lamps',
+            # 0x1002 => seen for WBAdjMode modes of Underwater and Calculate Automatically
         },
     },
@@ -462,4 +486,5 @@
             0 => 'Faster',
             1 => 'Better Quality',
+            2 => 'Better Quality 2013',
         },
     },
@@ -640,5 +665,5 @@
         Format => 'double',
         PrintConv => 'sprintf("%.4f", $val)',
-        PrintConvInvn => '$val',
+        PrintConvInv => '$val',
     },
     0x24 => {
@@ -655,4 +680,6 @@
             4 => 'High',
             6 => 'Extra High',
+            7 => 'Extra High 1',
+            8 => 'Extra High 2',
         },
     },
@@ -679,9 +706,9 @@
 sub WriteNikonCapture($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
-    $exifTool or return 1;    # allow dummy access to autoload this package
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    $et or return 1;    # allow dummy access to autoload this package
 
     # no need to edit this information unless necessary
-    unless ($exifTool->{EDIT_DIRS}->{MakerNotes} or $exifTool->{EDIT_DIRS}->{IPTC}) {
+    unless ($$et{EDIT_DIRS}{MakerNotes} or $$et{EDIT_DIRS}{IPTC}) {
         return undef;
     }
@@ -690,5 +717,5 @@
     my $dirLen = $$dirInfo{DirLen};
     if ($dirLen < 22) {
-        $exifTool->Warn('Short Nikon Capture Data',1);
+        $et->Warn('Short Nikon Capture Data',1);
         return undef;
     }
@@ -696,9 +723,9 @@
     SetByteOrder('II');
     my $tagID = Get32u($dataPt, $dirStart);
-    # sometimes size includes 18 header bytes, and other times it doesn't (ie. ViewNX 2.1.1)
+    # sometimes size includes 18 header bytes, and other times it doesn't (eg. ViewNX 2.1.1)
     my $size = Get32u($dataPt, $dirStart + 18);
-    my $pad = $dirLen - $size - 18; 
+    my $pad = $dirLen - $size - 18;
     unless ($tagID == 0x7a86a940 and ($pad >= 0 or $pad == -18)) {
-        $exifTool->Warn('Unrecognized Nikon Capture Data header');
+        $et->Warn('Unrecognized Nikon Capture Data header');
         return undef;
     }
@@ -712,5 +739,5 @@
     my $outBuff = '';
     my $pos;
-    my $newTags = $exifTool->GetNewTagInfoHash($tagTablePtr);
+    my $newTags = $et->GetNewTagInfoHash($tagTablePtr);
     my $dirEnd = $dirStart + $dirLen;
 
@@ -720,5 +747,5 @@
         $size = Get32u($dataPt, $pos + 18) - 4;
         last if $size < 0 or $pos + 22 + $size > $dirEnd;
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tagID);
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tagID);
         if ($tagInfo) {
             my $newVal;
@@ -732,23 +759,23 @@
                 my $subTable = GetTagTable($tagInfo->{SubDirectory}->{TagTable});
                 # ignore minor errors in IPTC since there is typically trailing garbage
-                my $oldSetting = $exifTool->Options('IgnoreMinorErrors');
-                $$tagInfo{Name} =~ /IPTC/ and $exifTool->Options(IgnoreMinorErrors => 1);
+                my $oldSetting = $et->Options('IgnoreMinorErrors');
+                $$tagInfo{Name} =~ /IPTC/ and $et->Options(IgnoreMinorErrors => 1);
                 # rewrite the directory
-                $newVal = $exifTool->WriteDirectory(\%subdirInfo, $subTable);
+                $newVal = $et->WriteDirectory(\%subdirInfo, $subTable);
                 # restore our original options
-                $exifTool->Options(IgnoreMinorErrors => $oldSetting);
+                $et->Options(IgnoreMinorErrors => $oldSetting);
             } elsif ($$newTags{$tagID}) {
                 # get new value for this tag if we are writing it
                 my $format = $$tagInfo{Format} || $$tagInfo{Writable};
                 my $oldVal = ReadValue($dataPt,$pos+22,$format,1,$size);
-                my $nvHash = $exifTool->GetNewValueHash($tagInfo);
-                if (Image::ExifTool::IsOverwriting($nvHash, $oldVal)) {
-                    my $val = $exifTool->GetNewValues($tagInfo);
+                my $nvHash = $et->GetNewValueHash($tagInfo);
+                if ($et->IsOverwriting($nvHash, $oldVal)) {
+                    my $val = $et->GetNewValue($tagInfo);
                     $newVal = WriteValue($val, $$tagInfo{Writable}) if defined $val;
                     if (defined $newVal and length $newVal) {
-                        ++$exifTool->{CHANGED};
+                        ++$$et{CHANGED};
                     } else {
                         undef $newVal;
-                        $exifTool->Warn("Can't delete $$tagInfo{Name}");
+                        $et->Warn("Can't delete $$tagInfo{Name}");
                     }
                 }
@@ -772,5 +799,5 @@
             $outBuff .= substr($$dataPt, $pos, 4);
         } else {
-            $exifTool->Warn('Nikon Capture Data improperly terminated',1);
+            $et->Warn('Nikon Capture Data improperly terminated',1);
             return undef;
         }
@@ -788,15 +815,15 @@
 sub ProcessNikonCaptureEditVersions($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dirStart = $$dirInfo{DirStart};
     my $dirLen = $$dirInfo{DirLen};
     my $dirEnd = $dirStart + $dirLen;
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
     SetByteOrder('II');
     return 0 unless $dirLen > 4;
     my $num = Get32u($dataPt, $dirStart);
     my $pos = $dirStart + 4;
-    $verbose and $exifTool->VerboseDir('NikonCaptureEditVersions', $num);
+    $verbose and $et->VerboseDir('NikonCaptureEditVersions', $num);
     while ($num) {
         last if $pos + 4 > $dirEnd;
@@ -810,10 +837,10 @@
             DirLen   => $len,
         );
-        $$exifTool{DOC_NUM} = ++$$exifTool{DOC_COUNT};
-        $exifTool->ProcessDirectory(\%dirInfo, $tagTablePtr);
+        $$et{DOC_NUM} = ++$$et{DOC_COUNT};
+        $et->ProcessDirectory(\%dirInfo, $tagTablePtr);
         --$num;
         $pos += $len + 4;
     }
-    delete $$exifTool{DOC_NUM};
+    delete $$et{DOC_NUM};
     return 1;
 }
@@ -825,13 +852,13 @@
 sub ProcessNikonCapture($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $dirStart = $$dirInfo{DirStart};
     my $dirLen = $$dirInfo{DirLen};
     my $dirEnd = $dirStart + $dirLen;
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
     my $success = 0;
     SetByteOrder('II');
-    $verbose and $exifTool->VerboseDir('NikonCapture', 0, $dirLen);
+    $verbose and $et->VerboseDir('NikonCapture', 0, $dirLen);
     my $pos;
     for ($pos=$dirStart+22; $pos+22<$dirEnd; ) {
@@ -840,5 +867,5 @@
         $pos += 22;
         last if $size < 0 or $pos + $size > $dirEnd;
-        my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tagID);
+        my $tagInfo = $et->GetTagInfo($tagTablePtr, $tagID);
         if ($tagInfo or $verbose) {
             my ($format, $value);
@@ -860,8 +887,10 @@
                 $value = substr($$dataPt, $pos, $size);
             }
-            $exifTool->HandleTag($tagTablePtr, $tagID, $value,
-                DataPt => $dataPt,
-                Start  => $pos,
-                Size   => $size,
+            $et->HandleTag($tagTablePtr, $tagID, $value,
+                DataPt  => $dataPt,
+                DataPos => $$dirInfo{DataPos},
+                Base    => $$dirInfo{Base},
+                Start   => $pos,
+                Size    => $size,
             ) and $success = 1;
         }
@@ -890,5 +919,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
